﻿using Microsoft.AspNetCore.Http;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Net;
using System.Text;
using System.Threading.Tasks;

namespace demo.Common
{
    public class HttpHelper
    {
        private static IHttpContextAccessor _accessor;
        public static void Configure(IHttpContextAccessor httpContextAccessor)
        {
            _accessor = httpContextAccessor;
        }

        public static Microsoft.AspNetCore.Http.HttpContext Current => _accessor.HttpContext;

        public static HttpContext HttpContext => _accessor.HttpContext;


        public static HttpRequest Request => _accessor.HttpContext.Request;

        public static HttpResponse Response => _accessor.HttpContext.Response;

        public static string Send(string url, string postData)
        {
            ServicePointManager.DefaultConnectionLimit = int.MaxValue;
            HttpWebRequest myReq = (HttpWebRequest)HttpWebRequest.Create(url);
            myReq.Method = "GET";
            myReq.Timeout = 10000;
            myReq.ContentType = "application/json";
            if (!string.IsNullOrEmpty(postData))
            {
                byte[] byteArray = Encoding.UTF8.GetBytes(postData);
                myReq.ContentLength = byteArray.Length;
                myReq.ServicePoint.ConnectionLimit = int.MaxValue;
                using (Stream reqStream = myReq.GetRequestStream())
                {
                    reqStream.Write(byteArray, 0, byteArray.Length);
                }
            }

            string returnString = string.Empty;
            using (HttpWebResponse response = (HttpWebResponse)myReq.GetResponse())
            {
                using (Stream resStream = response.GetResponseStream())
                {
                    using (StreamReader reader = new StreamReader(resStream, Encoding.UTF8))
                    {
                        returnString = reader.ReadToEnd();
                    }
                }
            }
            return returnString;
        }
    }
}
