﻿using demo.Common;
using Microsoft.AspNetCore.Mvc;
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Threading.Tasks;
using System.Web;

namespace demo.Controllers
{
    [Route("api/[controller]")]
    [ApiController]
    public class CallBackController : ControllerBase
    {
        
        static string AppID = "yme51ef06b32ac6cf1";                         //应用ID
        static string AppSercretKey = "7616c0fc4d2f4891b51d52b1e31fbdbd";   //应用密钥
        static string TcpTimeUrl = "http://47.106.88.200:90/ParkApi/";      //TCP服务接口
        static string UserNo = "1630583033426149";
        static string UserNowin = "1630583033426148";         //登录用户编号


        #region 回调接口

        /// <summary>
        /// 回调接口
        /// </summary>
        /// <returns></returns>
        [HttpPost("ThirdCallBack")]
        public ActionResult ThirdCallBack()
        {
            Model.ResultBase result = new Model.ResultBase();
            try
            {
                Dictionary<string, object> dic = GetPostDic();
                if (dic == null)
                {
                    result.code = 0;
                    result.msg = "不是Content-Type:application/json类型";
                    return ToJson(result);
                }
                if (dic.Keys.Contains("sign") && dic.Keys.Contains("appid") && dic.Keys.Contains("rand") && dic["sign"] != null && dic["appid"] != null && dic["rand"] != null)
                {
                    if (Common.SignHelper.SignVerify(dic["sign"].ToString(), dic, AppSercretKey))
                    {
                        string appid = dic["appid"].ToString();//appid
                        string method = dic["method"].ToString();//方法名
                        Dictionary<string, object> data = Newtonsoft.Json.JsonConvert.DeserializeObject<Dictionary<string, object>>(dic["data"].ToString());
                        data.Add("actionname", method);
                        //string deviceno = data["deviceno"].ToString();      //设备编号
                        //string callid = data["callid"].ToString();          //呼叫ID
                        //string bnum = data["bnum"].ToString();              //楼栋编号
                        //string hnum = data["hnum"].ToString();              //房间号
                        //string account = data["account"].ToString();        //账号
                        //string pwd = data["pwd"].ToString();                //密码

                        if (method == "applycall")
                        {
                            //TODO ...
                            string json = JsonConvert.SerializeObject(data);
                            //发送TCP消息(此处用HTTP请求TCP服务转发)
                            string action = "/Talking?terminalId=" + UserNo + "&pullDataStr=" + HttpUtility.UrlEncode(JsonConvert.SerializeObject(data).Replace("\r\n", ""), System.Text.Encoding.UTF8);
                            string r = HttpHelper.Send(TcpTimeUrl.TrimEnd('/') + action, "");
                            //同时转发多个账号
                            //string actionwin = "/Talking?terminalId=" + UserNowin + "&pullDataStr=" + HttpUtility.UrlEncode(JsonConvert.SerializeObject(data).Replace("\r\n", ""), System.Text.Encoding.UTF8);
                            //string rwin = HttpHelper.Send(TcpTimeUrl.TrimEnd('/') + actionwin, "");
                        }
                        else if (method == "closecall")
                        {
                            //TODO ...

                            //发送TCP消息(此处用HTTP请求TCP服务转发)
                            string action = "/Talking?terminalId=" + UserNo + "&pullDataStr=" + HttpUtility.UrlEncode(JsonConvert.SerializeObject(data).Replace("\r\n", ""), System.Text.Encoding.UTF8);
                            string r = HttpHelper.Send(TcpTimeUrl.TrimEnd('/') + action, "");
                            //同时转发多个账号
                            //string actionwin = "/Talking?terminalId=" + UserNowin + "&pullDataStr=" + HttpUtility.UrlEncode(JsonConvert.SerializeObject(data).Replace("\r\n", ""), System.Text.Encoding.UTF8);
                            //string rwin = HttpHelper.Send(TcpTimeUrl.TrimEnd('/') + actionwin, "");
                        }
                    }
                    else
                    {
                        result.code = 0;
                        result.msg = "签名校验失败";
                        return ToJson(result);
                    }
                }
                else
                {
                    result.code = 0;
                    result.msg = "参数错误";
                    return ToJson(result);
                }
                result.code = 1;
                result.msg = "ok";
                return ToJson(result);

            }
            catch (Exception ex)
            {
                result.code = -1;
                result.msg = ex.Message;
                return ToJson(result);
            }
        }
        #endregion

        public Dictionary<string, object> GetPostDic()
        {
            string postString = "";
            using (var read = new StreamReader(HttpContext.Request.Body))
            {
                postString = read.ReadToEnd();
            }
            if (!string.IsNullOrEmpty(postString))
                return JsonConvert.DeserializeObject<Dictionary<string, object>>(postString);
            else
                return new Dictionary<string, object>();
        }

        /// <summary>
        /// Object转ActionResult
        /// </summary>
        /// <param name="obj"></param>
        /// <returns></returns>
        public static ContentResult ToJson(Object obj)
        {
            string str;
            if (obj is String || obj is Char)
            {
                str = obj.ToString();
            }
            else
            {
                str = JsonConvert.SerializeObject(obj);
            }
            Common.HttpHelper.Current.Response.Headers.Add("Content-Length", str.Length.ToString());

            var c = new ContentResult();
            c.Content = str;
            return c;
        }
    }
}
